--- usr/sbin/pkcsslotd/err.c.orig	2010-07-29 21:28:41.000000000 +0900
+++ usr/sbin/pkcsslotd/err.c	2010-10-20 01:17:17.245985003 +0900
@@ -288,6 +288,7 @@
 
 /* (C) COPYRIGHT International Business Machines Corp. 2001          */
 
+#include <signal.h>
 
 #include "pthread.h"
 
@@ -331,14 +332,30 @@
 	CONSTINFO(ERANGE), 
 	CONSTINFO(ENOMSG), 
 	CONSTINFO(EIDRM), 
+#ifdef ECHRNG
 	CONSTINFO(ECHRNG), 
+#endif
+#ifdef EL2NSYNC
 	CONSTINFO(EL2NSYNC), 
+#endif
+#ifdef EL3HLT
 	CONSTINFO(EL3HLT), 
+#endif
+#ifdef EL3RST
 	CONSTINFO(EL3RST), 
+#endif
+#ifdef ELNRNG
 	CONSTINFO(ELNRNG), 
+#endif
+#ifdef EUNATCH
 	CONSTINFO(EUNATCH), 
+#endif
+#ifdef ENOCSI
 	CONSTINFO(ENOCSI), 
+#endif
+#ifdef EL2HLT
 	CONSTINFO(EL2HLT), 
+#endif
 	CONSTINFO(EDEADLK),
 	CONSTINFO(ESTALE), 
 	CONSTINFO(EWOULDBLOCK), 
@@ -369,7 +386,9 @@
 	CONSTINFO(ECONNREFUSED), 
 	CONSTINFO(EHOSTDOWN), 
 	CONSTINFO(EHOSTUNREACH), 
+#ifdef ERESTART
 	CONSTINFO(ERESTART), 
+#endif
 	CONSTINFO(EUSERS), 
 	CONSTINFO(ELOOP), 
 	CONSTINFO(ENAMETOOLONG), 
@@ -380,16 +399,34 @@
 	CONSTINFO(ETOOMANYREFS), 
 	CONSTINFO(EILSEQ), 
 	CONSTINFO(ECANCELED), 
+#ifdef ENOSR
 	CONSTINFO(ENOSR), 
+#endif
+#ifdef ETIME
 	CONSTINFO(ETIME), 
+#endif
+#ifdef EBADMSG
 	CONSTINFO(EBADMSG), 
+#endif
+#ifdef EPROTO
 	CONSTINFO(EPROTO), 
+#endif
+#ifdef ENODATA
 	CONSTINFO(ENODATA), 
+#endif
+#ifdef ENOSTR
 	CONSTINFO(ENOSTR), 
+#endif
 	CONSTINFO(ENOTSUP), 
+#ifdef EMULTIHOP
 	CONSTINFO(EMULTIHOP), 
+#endif
+#ifdef ENOLINK
 	CONSTINFO(ENOLINK), 
+#endif
+#ifdef EOVERFLOW
 	CONSTINFO(EOVERFLOW),
+#endif
 
   };
 
@@ -424,14 +461,20 @@
 	CONSTINFO(SIGXCPU), 
 	CONSTINFO(SIGXFSZ), 
 	CONSTINFO(SIGWINCH), 
+#ifdef SIGPWR
 	CONSTINFO(SIGPWR), 
+#endif
 	CONSTINFO(SIGUSR1), 
 	CONSTINFO(SIGUSR2), 
 	CONSTINFO(SIGPROF), 
 	CONSTINFO(SIGVTALRM), 
 	CONSTINFO(SIGIOT), 
+#ifdef SIGCLD
 	CONSTINFO(SIGCLD), 
+#endif
+#ifdef SIGPOLL
 	CONSTINFO(SIGPOLL), 
+#endif
         #if 0
 	  CONSTINFO(SIG_DFL), 
 	  CONSTINFO(SIG_IGN), 
